<?xml version="1.0"?>
<!--
	The lestes compiler suite
	Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
	Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
	Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
	Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
	Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
	Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
	Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	See the full text of the GNU General Public License version 2, and
	the limitations in the file doc/LICENSE.

	By accepting the license the licensee waives any and all claims
	against the copyright holder(s) related in whole or in part to the
	work, its use, and/or the inability to use it.
-->
<!DOCTYPE xsl:transform [
	<!ENTITY nl "&#x0A;">
	<!ENTITY tab "&#x09;">
]>
<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lsd="http://lestes.jikos.cz/schemas/lsd" xmlns:lvd="http://lestes.jikos.cz/schemas/lvd">
	<!-- Generate abstract class for each visitor. -->
	<xsl:output method="text" encoding="ISO-8859-1"/>

	<xsl:template match="/lvd:lvd">
		<xsl:text>// This file is automatically generated, do not edit.&nl;&nl;</xsl:text>
		<xsl:for-each select="lvd:dox">	<!-- doxygen info about output file -->
			<xsl:text>&nl;/*! \file&nl;</xsl:text>
			<xsl:if test="string-length(lvd:bri)">
				<xsl:value-of select="concat('    \brief ',lvd:bri,'&nl;')"/>
			</xsl:if>
			<xsl:if test="string-length(lvd:det)">
				<xsl:text>    </xsl:text>
				<xsl:apply-templates mode="html-text" select="lvd:det/node()"/>
				<xsl:text>&nl;</xsl:text>
			</xsl:if>
			<xsl:text>*/&nl;&nl;</xsl:text>
		</xsl:for-each>

		<xsl:call-template name="open-header"/>

		<xsl:call-template name="imports"/>		<!-- #include ... -->
		<xsl:call-template name="open-packages"/>	<!-- package(...); -->

		<xsl:if test="lvd:hh-header/text() != ''">
			<xsl:value-of select="concat('&nl;',lvd:hh-header,'&nl;&nl;')"/>		<!-- output file prolog -->
			<xsl:text>&nl;</xsl:text>
		</xsl:if>

		<!-- end of prolog -->

		<xsl:for-each select="lvd:visitors/lvd:v">
			<xsl:variable name="name" select="@name"/>
			<!-- remember the visitor's name -->
			<xsl:variable name="doc">
				<!-- the document, where is the base class, containing the visitor -->
				<xsl:call-template name="get-doc">
					<xsl:with-param name="name" select="$name"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="class">
				<!-- name of the base class, containing the visitor -->
				<xsl:call-template name="get-class">
					<xsl:with-param name="name" select="$name"/>
					<xsl:with-param name="doc" select="$doc"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:variable name="type">
				<!-- visitor's return type -->
				<xsl:call-template name="get-type">
					<xsl:with-param name="name" select="$name"/>
					<xsl:with-param name="doc" select="$doc"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="concat('class ',$name,' : public ::lestes::std::visitor_base {&nl;')"/>
			<xsl:text>public: &nl;</xsl:text>
			<xsl:for-each select="/lvd:lvd/lvd:uses">
				<xsl:apply-templates mode="visit-decl" select="document(@href,.)/lsd:lsd/lsd:class[ string(@abstract) != 'yes' ]">
					<!-- for all non-abstract classes -->
					<xsl:with-param name="visitor-name" select="$name"/>
					<xsl:with-param name="visitor-type" select="$type"/>
				</xsl:apply-templates>
			</xsl:for-each>
			<xsl:text>};&nl;&nl;</xsl:text>
			<xsl:for-each select="./lvd:special">
				<xsl:variable name="special-name" select="@name"/>
				<xsl:value-of select="concat('class ',$special-name,' : public ',$name,' {&nl;')"/>
				<xsl:text>public:&nl;</xsl:text>
				<xsl:for-each select="lvd:cut">
					<xsl:text>&tab;virtual </xsl:text>
					<xsl:value-of select="concat($type,' ',@method,'( ptr&lt; ',@at,' &gt; ) abstract;&nl;')"/>
				</xsl:for-each>
				<xsl:text>&nl;</xsl:text>
				<xsl:for-each select="lvd:cut">
					<xsl:variable name="at" select="@at"/>
					<xsl:variable name="method" select="@method"/>
					<xsl:for-each select="/lvd:lvd/lvd:uses">
						<xsl:apply-templates mode="visit-decl-special" select="document(@href,.)/lsd:lsd/lsd:class[ string(@abstract) != 'yes' ]">
							<!-- for all non-abstract classes -->
							<xsl:with-param name="visitor-name" select="$name"/>
							<xsl:with-param name="visitor-type" select="$type"/>
							<xsl:with-param name="cut-class" select="$at"/>
						</xsl:apply-templates>
					</xsl:for-each>
				</xsl:for-each>
				<xsl:text>};&nl;&nl;</xsl:text>
			</xsl:for-each>
		</xsl:for-each>

		<!-- epilog -->
		<xsl:if test="lvd:hh-footer/text() != ''">
			<xsl:value-of select="concat('&nl;',lvd:hh-footer,'&nl;')"/>		<!-- output file epilog -->
		</xsl:if>

		<xsl:call-template name="close-packages"/>	<!-- end_package(...); -->

		<xsl:call-template name="close-header"/>

	</xsl:template>

	<xsl:template mode="visit-decl" match="lsd:class">
		<xsl:message>
			<xsl:value-of select="concat('visit-decl: clas/@name = &quot;',@name,'&quot;&nl;')" />
		</xsl:message>
		<xsl:param name="visitor-name"/>
		<xsl:param name="visitor-type"/>
		<xsl:variable name="haveit">
			<xsl:apply-templates mode="visitor-present" select=".">
				<xsl:with-param name="name" select="$visitor-name"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:if test="$haveit = 'yes'">
			<xsl:value-of select="concat('&tab;virtual ',$visitor-type,' visit_',@name)"/>
			<xsl:text>( ptr&lt; </xsl:text>
			<xsl:for-each select="/lsd:lsd/lsd:packages/lsd:p">
				<xsl:value-of select="concat('::',./text())" />
			</xsl:for-each>
			<xsl:value-of select="concat('::',@name,' &gt; )')" />
			<xsl:text> abstract;&nl;</xsl:text>
		</xsl:if>
	</xsl:template>

	<xsl:template mode="visit-decl-special" match="lsd:class">
		<xsl:param name="visitor-name"/>
		<xsl:param name="visitor-type"/>
		<xsl:param name="cut-class"/>
		<xsl:variable name="haveit">
			<xsl:apply-templates mode="visitor-present" select=".">
				<xsl:with-param name="name" select="$visitor-name"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="undercut">
			<xsl:apply-templates mode="under-cut" select=".">
				<xsl:with-param name="cut-class" select="$cut-class"/>
			</xsl:apply-templates>
		</xsl:variable>
<!--		<xsl:value-of select="concat('/* visitor-name:',$visitor-name,' visitor-type:',$visitor-type,' cut-class:',$cut-class,' haveit:',$haveit,' undercut:',$undercut,' @name:',@name,' */&nl;')"/> -->
		<xsl:if test="($haveit = 'yes') and ($undercut = 'yes')">
			<xsl:value-of select="concat('&tab;virtual ',$visitor-type,' visit_',@name)"/>
			<xsl:value-of select="concat('( ptr&lt; ',@name,' &gt; );&nl;')"/>
		</xsl:if>
	</xsl:template>

	<xsl:include href="lvd_common.xslt"/>

</xsl:transform>
